package com.banctec.caseware.server.actionpersister;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;

import javax.ejb.RemoveException;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

@Stateless(name = "ActionPersister")
@TransactionAttribute(TransactionAttributeType.REQUIRED)
public class ActionPersisterFacade implements Serializable, ActionPersisterLocal {

	private static final long serialVersionUID = -3370435796961373902L;
	private static final String FULLCLASS = "com.banctec.caseware.server.actionpersister.ActionPersisterBean";
	private static final String CLASS = "ActionPersisterBean";
	@PersistenceContext
	private EntityManager em;

	@SuppressWarnings("unchecked")
	public Collection<ActionPersisterBean> findAllActions() {
		Query query = em.createNamedQuery("findAllActions");
		return query.getResultList();
	}

	@SuppressWarnings("unchecked")
	public Collection<ActionPersisterBean> findActions(String action) {
		Query query = em.createNamedQuery("findActions");
		query.setParameter(1, action);
		return query.getResultList();
	}

	@SuppressWarnings("unchecked")
	public ActionPersisterBean findActionByName(String name) {
		Query query = em.createNamedQuery("findActionByName");
		query.setParameter(1, name);
		List<ActionPersisterBean> result = query.getResultList();
		if (result != null) {
			return result.get(0);
		}
		return null;
	}

	public ActionPersisterBean findByPrimaryKey(Long pk) {
		return em.find(ActionPersisterBean.class, pk);
	}

	public void remove(Long id) throws RemoveException {
		ActionPersisterBean ab = findByPrimaryKey(id);
		if (ab == null) {
			throw new RemoveException();
		}
		em.remove(ab);
	}
}